-------------------------------------------------------------------
--           RAPID - RAPID ADA PORTABLE INTERFACE DESIGNER         
--           MCC GUI PACKAGE LIBRARY                               
--           Copyright (C) 1999 Martin C. Carlisle.                
--                                                                 
-- RAPID is free software;  you can  redistribute it  and/or modify
-- it under terms of the  GNU General Public License as published  
-- by the Free Software  Foundation;  either version 2,  or (at your
-- option) any later version.  RAPID is distributed in the hope that 
-- it will be useful, but WITHOUT ANY WARRANTY;  without even the 
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-- PURPOSE.  See the GNU General Public License for more details.  
-- You should have  received  a copy of the GNU General Public License
-- distributed with RAPID; see file COPYING.  If not, write to the 
-- Free Software Foundation,  59 Temple Place - Suite 330,  Boston, 
-- MA 02111-1307, USA.                                                 
--                                                                     
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an 
-- executable, this unit does not by itself cause the resulting 
-- executable to be covered by the GNU General Public License.  
-- This exception does not however invalidate any other reasons 
-- why the executable file might be covered by the GNU Public 
-- License.  This exception does not apply to executables which
-- are GUI design tools, or that could act as a replacement
-- for RAPID.
-----------------------------------------------------------------------------
with gdk;
with gdk.font;
with Gtk.Style;
with Gtk.Widget;
with Peer.Style;
with Ada.Unchecked_Conversion;
package body Mcc.Gui.Fonts is
   type String_Pointer is access all String;
   type Family_Array is array(Font_Family) of String_Pointer;
   type Style_Array is array(Font_Style) of String_Pointer;
   Family_Names : Family_Array := 
      (Serif      => new String'("times"),
       Sans_Serif => new String'("helvetica"),
       Monospaced => new String'("courier"));
   Style_Names : Style_Array :=
      (Plain       => new String'("-medium-r-"),
       Bold        => new String'("-bold-r-"),
       Italic      => new String'("-medium-i-"),
       Bold_Italic => new String'("-bold-i-"));
   function Convert is new Ada.Unchecked_Conversion(
      Gdk.Font.Gdk_Font,Peer.Peer);
   function Convert is new Ada.Unchecked_Conversion(
      Peer.Peer,Gdk.Font.Gdk_Font);
   ------------
   -- Create --
   ------------

   procedure Create
     (Obj    : in out Font;
      Family : in     Font_Family := Serif;
      Size   : in     Font_Size := 12;
      Style  : in     Font_Style := Plain)
   is
      function Font_Image(Size : Font_Size) return String is
         x : String := Font_Size'Image(Size);
      begin
         return x(x'first+1..x'last);
      end Font_Image;
      Font : Gdk.Font.Gdk_Font;
   begin
      -- -foundry-family-weight-slant-width- -pixel sz-pt sz-res x-res y
      -- -spacing-avg width-registry-encoding
      Gdk.Font.Load(
         Font      => Font, 
         Font_Name => "-*-" & Family_Names(Family).all &
            Style_Names(Style).all & "*- -" & Font_Image(Size) &
            "-*-*-*-*-*-*-*");
      Obj.My_Peer := Convert(Font);
   end Create;

   --------------
   -- Set_Font --
   --------------

   procedure Set_Font
     (Obj      : in out Sized_Object'Class;
      New_Font : in     Font)
   is
      old_style : gtk.style.gtk_style;
      new_style : gtk.style.gtk_style;
   begin
      --create a new_style
      Old_Style := Gtk.Widget.Get_Style(Gtk.Widget.Gtk_Widget(Obj.My_Peer));
      New_Style := Gtk.Style.Copy(Old_Style);
      Gtk.Style.Set_Font(New_Style,Convert(New_Font.My_Peer));
      Peer.Style.Set_Style_Recursively (
         Widget => Gtk.Widget.Gtk_Widget(Obj.My_Peer), 
         Style  => New_Style);
   end Set_Font;

end Mcc.Gui.Fonts;

